---
title: Firefox 13 for developers
slug: Mozilla/Firefox/Releases/13
tags:
  - Firefox
  - Gecko
---
<div>{{FirefoxSidebar}}</div>

<p>Firefox 13 was shipped on June 5, 2012. This page summarizes the changes in Firefox 13 that affect developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Tables' {{htmlattrxref("cellspacing", "table")}} attributes are now parsed the same outside quirks mode as they are in quirks mode. That is, if a value is specified as a percentage, it's treated as a number of pixels instead, since percentage values are not actually permitted according to the specification.</li>
 <li>The {{htmlelement("wbr")}} element has seen its bidirectional behavior fixed. It now behaves like the Unicode <code>U+200B</code><code> ZERO-WIDTH SPACE</code> and therefore doesn't affect bi-directionality of its parent element anymore.</li>
 <li>The {{Cssxref(":invalid")}} pseudo-class can now be applied to the {{htmlelement("form")}} element.</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The <code>turn</code> {{cssxref("&lt;angle&gt;")}} unit is now supported (to be used with CSS functions like <code>rotate()</code>).</li>
 <li>Support for 3-to-4 value syntax of the {{cssxref("background-position")}} has been added. You can offset a background image from any corner by writing like "<code>right 10px bottom 20px</code>". See {{bug("522607")}}</li>
 <li>Support for the 2-value syntax of the CSS {{cssxref("background-repeat")}} has been added.</li>
 <li>Support for {{cssxref("border-radius","-moz-border-radius*")}} and {{cssxref("box-shadow","-moz-box-shadow")}} has been removed. Authors should use unprefixed <code>border-radius</code> or <code>box-shadow</code> instead. See {{bug("693510")}}</li>
 <li>The {{cssxref("column-fill")}} property has been implemented (prefixed).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>Support for the ECMAScript 2015 <a href="/en-US/docs/JavaScript/Reference/Statements/for...of" title="for...of"><code>for..of</code></a> construct has been added.</li>
 <li>Experimental support for ECMAScript 2015 <a href="/en-US/docs/JavaScript/Reference/Global_Objects/Map" title="https://developer.mozilla.org/en-US/docs/JavaScript/Reference/Global_Objects/Map">Map</a> and <a href="/en-US/docs/JavaScript/Reference/Global_Objects/Set" title="https://developer.mozilla.org/en-US/docs/JavaScript/Reference/Global_Objects/Set">Set</a> objects has been implemented.</li>
</ul>

<h3 id="DOM">DOM</h3>

<ul>
 <li>The {{domxref("Node.cloneNode()")}} method's <code>deep</code> argument is now optional, as specified in DOM4.</li>
 <li>The {{domxref("window.setTimeout()")}} and {{domxref("window.setInterval()")}} methods no longer pass an additional "lateness" argument to the callback routine.</li>
 <li>The {{domxref("Blob","Blob.mozSlice()")}} method has been unprefixed.</li>
 <li>Support for the {{domxref("Blob")}} constructor has been added.</li>
 <li>Support for <a href="/en-US/docs/DOM/Storage#globalStorage" title="en-US/docs/DOM/Storage#globalStorage"><code>globalStorage</code></a> has been removed.</li>
 <li>The new {{domxref("DOMRequest")}} interface, used for reporting the status and result of background operations, has been added.</li>
 <li>The {{domxref("HTMLOptionElement", "HTMLOptionElement.index()")}} method now returns <code>0</code> instead of the incorrect <code>-1</code> when the {{HTMLElement("option")}} is inside a {{HTMLElement("datalist")}} HTML element.</li>
 <li>{{domxref("DOMException")}} as defined in DOM Level 4 has been implemented.</li>
 <li>The {{domxref("FileError")}} interface has been removed in favor of the {{domxref("DOMError")}} interface as defined in the latest FileAPI specification.</li>
 <li>The {{domxref("Range")}} object no longer throws a <code>RangeException</code>. Instead a {{domxref("DOMException")}} as defined in DOM 4 is used.</li>
 <li>{{domxref("element.getAttributeNS()")}} now always returns <code>null</code> instead of the empty string for non-existent attributes. Previously, there were cases in which the empty string could be returned. This is in keeping with the DOM4 specification, which now says this should return null for non-existent attributes, instead of an empty string.</li>
 <li>The {{domxref("HTMLCanvasElement")}} interface now has a non-standard <code>mozFetchAsStream()</code> method, which provides an input stream containing the element's image data in the specified format.</li>
</ul>

<h3 id="UA_string">UA string</h3>

<ul>
 <li>Firefox for Android now has a <a href="/en-US/docs/Gecko_user_agent_string_reference#Mobile_and_Tablet_indicators" title="en-US/docs/Gecko_user_agent_string_reference#Mobile_and_Tablet_indicators">Tablet or Mobile token in the UA string</a> to indicate the form factor and no longer has the Fennec token. Also, the number after "Gecko/" is now the Gecko version number instead of a frozen date.</li>
 <li>The UA string no longer exposes the Gecko patch number or release status in the version number; that is, the version number is now always of the form "X.Y", where X is the major release number and Y the minor. For example, "13.0" or "14.1". It will no longer be something like "14.0.1b1".</li>
</ul>

<h3 id="SVG">SVG</h3>

<ul>
 <li>The {{domxref("SVGStringList")}} DOM interface is now indexable like <a href="/en-US/docs/JavaScript/Reference/Global_Objects/Array" title="Array"><code>Array</code></a> (see {{bug("722071")}}).</li>
</ul>

<h3 id="WebGL">WebGL</h3>

<ul>
 <li>Support has been added for the <a href="/en-US/docs/WebGL/Using_Extensions#EXT_texture_filter_anisotropic" title="en-US/docs/WebGL/Using_Extensions#EXT_texture_filter_anisotropic"><code>EXT_texture_filter_anisotropic</code></a> extension. Anisotropic texture filtering improves the quality of mipmapped texture access when viewing a textured primitive at an oblique angle.</li>
</ul>

<h3 id="MathML">MathML</h3>

<ul>
 <li>Support for the <code>width</code> attribute on {{MathMLElement("mtable")}} elements has been added ({{bug("722880")}}).</li>
 <li><a class="external" href="http://cdn.mathjax.org/mathjax/latest/fonts/HTML-CSS/TeX/otf/" rel="external" title="http://cdn.mathjax.org/mathjax/latest/fonts/HTML-CSS/TeX/otf/">MathJax fonts</a> are now used as the default fonts for mathematical text. See <a href="/en-US/docs/Mozilla_MathML_Project/Fonts" title="Fonts for Mozilla's MathML engine">Fonts for Mozilla's MathML engine</a> for more information.</li>
</ul>

<h3 id="Network">Network</h3>

<ul>
 <li>The SPDY protocol now enabled by default.</li>
</ul>

<h3 id="Developer_tools">Developer tools</h3>

<h4 id="3D_view_improvements">3D view improvements</h4>

<ul>
 <li>You can now press the "f" key to make sure the currently selected node is visible.</li>
</ul>

<h4 id="Style_panel_improvements">Style panel improvements</h4>

<ul>
 <li>Clicking the heading for any rule in the <a href="/en-US/docs/Tools/Page_Inspector/Style_panel" title="Style panel">style panel</a> now opens the <a href="/en-US/docs/Tools/Style_Editor" title="Style Editor">Style Editor</a> at the corresponding CSS.</li>
 <li>Right-clicking on a rule in the <a href="/en-US/docs/Tools/Page_Inspector/Style_panel" title="Style panel">style panel</a> now offers an option to copy the rule to the clipboard.</li>
 <li>Entering an unknown property name, or an illegal property value, displays a warning icon next to that property.</li>
</ul>

<h4 id="Scratchpad_improvements">Scratchpad improvements</h4>

<ul>
 <li>The <a href="/en-US/docs/Tools/Scratchpad" title="Scratchpad">Scratchpad</a> now has an option in the Help menu to take you to the MDN documentation about Scratchpad.</li>
</ul>

<h2 id="Changes_for_Mozilla_and_add-on_developers">Changes for Mozilla and add-on developers</h2>

<h3 id="Compatibility_note">Compatibility note</h3>

<p>Starting in Firefox 13, Firefox for Windows requires at least Windows XP Service Pack 2; it will no longer run on Windows 2000 or earlier versions of Windows XP.</p>

<h3 id="JavaScript_code_modules">JavaScript code modules</h3>

<h4 id="source-editor.jsm">source-editor.jsm</h4>

<ul>
 <li>Support for a dirty flag has been added to the Source Editor API.</li>
 <li>The Source Editor no longer supports falling back to a {{HTMLElement("textarea")}} instead of using Orion.</li>
 <li>The editor now exposes focus and blur events.</li>
 <li>The <a href="/en-US/docs/JavaScript_code_modules/source-editor.jsm#getIndentationString%28%29" title="en-US/docs/JavaScript_code_modules/source-editor.jsm#getIndentationString%28%29"><code>getIndentationString()</code></a> method has been added; this returns the string to use for indenting text in the editor.</li>
 <li>The Source Editor now supports managing a list of breakpoints and displaying user interface for toggling them on and off; it does not actually implement breakpoints, however. That's up to you to write debugger code for.</li>
 <li>Support has been added for highlighting the current line, using the <code>highlightCurrentLine</code> configuration option.</li>
</ul>

<h3 id="ARIA">ARIA</h3>

<ul>
 <li>The CSS properties {{cssxref("margin-left")}}, {{cssxref("margin-right")}}, {{cssxref("margin-top")}}, {{cssxref("margin-bottom")}} are now all reflected into ARIA object attributes with the same name. See <a href="/en-US/docs/Accessibility/AT-APIs/Gecko/Attrs" title="Gecko Object Attributes">Gecko object attributes</a> for more information.</li>
</ul>

<h3 id="Interfaces">Interfaces</h3>

<ul>
 <li>The {{interface("nsIScreen")}} interface now supports controlling rotation through the new <code>rotation</code> attribute.</li>
 <li>The {{interface("nsIPrefBranch2")}} interface has been merged into {{interface("nsIPrefBranch")}} ({{bug("718255")}}).</li>
 <li>The new message manager wakeup service, implemented by {{interface("nsIMessageWakeupService")}}, has been implemented. See {{bug(591052)}}.</li>
 <li>The aliases <code>MozOpacity</code>, <code>MozOutline</code>, <code>MozOutlineStyle</code>, <code>MozOutlineWidth</code>, <code>MozOutlineOffset</code>, and <code>MozOutlineColor</code>, all of which were removed in previous versions of Gecko, have been removed from {{interface("nsIDOMCSS2Properties")}}, which should have been done with the aliases were initially removed.</li>
 <li>The {{interface("nsINavHistoryQueryOptions")}} attribute <code>excludeItemIfParentHasAnnotation</code> has been removed, along with the corresponding query operation. It existed to support livemarks, which no longer exist.</li>
</ul>

<h2 id="See_also">See also</h2>

<div>{{Firefox_for_developers('12')}}</div>
